import cPickle
import numpy as np
import matplotlib.pyplot as plt
import matplotlib.mlab as mlab
import matplotlib
from matplotlib.ticker import FuncFormatter

import pylab

def printtime(mins,pos=0):
    h = float(mins)/float(60)
    hint = int(h)
    m = (h-hint)*60
    mint = int(m)
    s = (m-mint)*60
    sint = int(s)
    #return str(hint)+":"+str(mint)+":"+str(sint) 
    return "%d:%02d:%02d"%(hint,mint,sint)
if __name__ == "__main__":  
    serie =      ["HCR_0_130", "HCR_M_16","HCR_N_16","HCR_M_40","HCR_M_50","HCR_M_60","HCR_N_35","HCR_N_45","HCR_N_55"]
    n_serie = 8
    timelist = cPickle.load(open( serie[n_serie], 'rb'))
    print " loaded ", len(timelist)," times from disk"
    
    fig = plt.figure()
    ax = fig.add_subplot(111)
    # histogram
    n, bins, patches = ax.hist( timelist , 100, normed=0, facecolor='green', alpha=0.75)
    ax.set_title('Helsinki City Run, 7.5.2011')
    ax.set_xlabel('Time')
    ax.set_ylabel('N')
    mu = np.average(timelist)
    std = np.std(timelist)
    
    pylab.text(2.75*60, 0.6*max(n), 'Sarja=%s\nN=%i\nmu=%s\nsigma=%s'%(serie[n_serie],len(timelist), printtime(mu), printtime(std)))
    
    mux=[mu , mu] # position of mu-line
    muy=[0 , 450] # y-coords for mu-line
    splus=[mu+std , mu+std]  # +std line
    sminus=[mu-std , mu-std] # -std line
    plt.plot(mux,muy, 'r-')
    plt.plot(splus,muy, 'r--')
    plt.plot(sminus,muy, 'r--')
    locs = []
    tloc = 60
    locs.append(tloc)
    while tloc<7*60:
        tloc=tloc+5 # x-axis tickmarks every 15min
        locs.append(tloc)
        
    ax.xaxis.set_major_locator( matplotlib.ticker.FixedLocator( locs )  )
    
    
    formatter = FuncFormatter(printtime)
    ax.xaxis.set_major_formatter(formatter)
    fig.autofmt_xdate(rotation=90)
    ax.set_xlim(1.0*60, 3.5*60)
    #ax.set_ylim(0, 300)
    ax.set_ylim(0, 1.1*max(n))
    ax.grid(True)
        
    #ax.grid(True)
    plt.savefig( serie[n_serie]+"_fig.png")
    #plt.show()
    plt.show()
